create or replace PROCEDURE SP_ALTA_MODIF_EST1 
IS
/******************************************************************************
   Nom   :              SP_ALTA_MODIF_EST1
   Propsito:           Modifica el valor de la entrada de la taula EST1_NUMTOTALDESCARREGUES. 
                        
                        La informaci actualitzada correspon al  nmero total de descrregues 
			que s'han fet fins al moment
                   
   Parmetres entrada:  sense parmetres           

   Retorna:             'OK' si l'execuci ha finalitzat amb xit
                        'ERROR: tipus d'error' si ha fracassat        
   
******************************************************************************/
paramEntrada      VARCHAR2(500);
RSP               VARCHAR2 (500);
existeix          INTEGER;
p_numDescarregues NUMBER;
err_msg           VARCHAR2 (200);

BEGIN

   paramEntrada:='sense parametres';

  -- calculem el nou nmero total de descrregues de la plataforma fins al moment
   SELECT COUNT (*)
   INTO p_numDescarregues
   FROM DESCARREGUES;

  -- calculem si existeix una entrada en la taula EST1_NUMTOTALDESCARREGUES
   SELECT COUNT (*)
   INTO existeix
   FROM EST1_NUMTOTALDESCARREGUES; 
  
  --Si no existeix l'entrada, l'afegim 
   
     IF (existeix=0) THEN 
     INSERT INTO EST1_NUMTOTALDESCARREGUES (numDescarregues) VALUES (p_numDescarregues);     
  
   --Si existeix l'actualitzem
   ELSE
     UPDATE EST1_NUMTOTALDESCARREGUES 
     SET numDescarregues=p_numDescarregues;
   END IF;  

  -- finaliza amb xit
   RSP:='OK';
   SP_ALTA_LOG1(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'SP_ALTA_MODIF_EST1', paramEntrada, 'RSP: '||RSP);

   COMMIT;
EXCEPTION

  -- no finaliza amb xit       
   WHEN OTHERS THEN
        err_msg:=SUBSTR (SQLERRM, 1, 200);
        RSP:='ERROR EST1: '||err_msg;
        SP_ALTA_LOG1(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'SP_ALTA_MODIF_EST1', paramEntrada, 'RSP: '||RSP);
        ROLLBACK;
              
END SP_ALTA_MODIF_EST1;