create or replace PROCEDURE SP_ALTA_MODIF_EST2 
IS
/******************************************************************************
   Nom:                 SP_ALTA_MODIF_EST2

   Propsit :           Afegeix una entrada a la taula estadstica EST2_TOTALEUROSDESC. 
                        La informaci introduda correspon  al nmero total de deuros 
                        generats en les descrregues que shan fet fins al moment
                   
   Parmetres entrada:  sense parmetres              

   Retorna:             'OK' si l'execuci ha finalitzat amb xit
                        'ERROR: tipus d'error' si ha fracassat
  
******************************************************************************/
paramEntrada    VARCHAR2(500);
RSP             VARCHAR2 (500);
existeix        INTEGER;
p_totalEuros    NUMBER;
err_msg         VARCHAR2 (200);

BEGIN

   paramEntrada:='sense parametres';

  -- calculem el nou nmero total d'euros generats en descarregues fins al moment
   SELECT SUM (preu)
   INTO p_totalEuros
   FROM DESCARREGUES;

  -- calculem si existeis una entrada en la taula EST2_TOTALEURODESC
   SELECT COUNT (*)
   INTO existeix
   FROM EST2_TOTALEUROSDESC; 
  
  --Si no existeix l'entrada, l'afegim 
   IF (existeix=0) THEN 
     INSERT INTO EST2_TOTALEUROSDESC (totalEuros) VALUES (p_totalEuros);     
  
  --Si existeix l'actualitzem
   ELSE
     UPDATE EST2_TOTALEUROSDESC 
     SET totalEuros=p_totalEuros;
   END IF;  

  -- finalitza amb xito
   RSP:='OK';
   SP_ALTA_LOG1(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'SP_ALTA_MODIF_EST2', paramEntrada, 'RSP: '||RSP);

   COMMIT;
EXCEPTION

  -- no finalitza amb xit       
   WHEN OTHERS THEN
        err_msg:=SUBSTR (SQLERRM, 1, 200);
        RSP:='ERROR LOG: '||err_msg;
        SP_ALTA_LOG1(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'SP_ALTA_MODIF_EST2', paramEntrada, 'RSP: '||RSP);
        ROLLBACK;
              
END SP_ALTA_MODIF_EST2;