create or replace PROCEDURE FU_LLISTAT_APLICACIONS (
   REFCURSOR OUT SYS_REFCURSOR, 
   RSP OUT VARCHAR2
)
IS
/******************************************************************************
   Nombre:              FU_LLISTAT_APLICACIONS

   Propsit:            El llistat de totes les aplicacions actives i les seves 
		        dades principals, ordenat pel nmero total de descrregues
		        que han tingut fins al moment a nivell mundial.
			y sus datos principales, ordenadas por el número de descargas
			
   Parmetres entrada:  sense parmetres

   Parmetres de sortida: REFCURSOR, RSP          

   Retorna:             'OK' si l'execuci ha finalitzat amb xit
                        'ERROR: tipus d'error' si ha fracassat
******************************************************************************/
paramEntrada         VARCHAR2(500);
err_msg              VARCHAR2(200);
num                  INTEGER;
    
BEGIN
   
   paramEntrada:='sense parmetres';

  OPEN REFCURSOR FOR
  SELECT ap.idAplicacio, ap.versio, ap.dataPujada, ap.resolucio, COUNT(d.dataDesc) AS num
  FROM APLICACIONS ap JOIN DESCARREGUES d ON ap.idAplicacio=d.aplicacio
  GROUP BY ap.idAplicacio, ap.versio, ap.dataPujada, ap.resolucio, num
  ORDER BY num DESC;
 
  
  -- finaltiza amb xit
   RSP:= 'OK';
   SP_ALTA_LOG1(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'FU_LLISTAT_APLICACIONS', paramEntrada, 'RSP: '||RSP);
  
  COMMIT;
  
EXCEPTION
  -- no finaltiza amb xit        
   WHEN OTHERS THEN
        err_msg:=SUBSTR (SQLERRM, 1, 200);
        RSP:='ERROR: '||err_msg;
        SP_ALTA_LOG1(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'FU_LLISTAT_APLICACIONS', paramEntrada, 'RSP: '||RSP); 
        ROLLBACK; 
   
END FU_LLISTAT_APLICACIONS;